function d = drand(p,m)
%
% DRAND: d = drand(p,m)
%
% drand returns m instances of a discrete random
% variable that assumes values 1,2,...,n with
% probabilities prob(1),prob(2),...,prob(n)
%
n = length(p);
u = rand(1,m); u = u(ones(n,1),:);
c = cumsum(p); c = c(:,ones(1,m));
[z d] = max(u<=c,[],1); d = d';
