function [x,fx] = fmaxsec(func,x,a,b,tol,maxit);
% successive linearization loop
y = x+2*tol;
i = find(x>b);
y(i) = x(i)-2*tol;
[fy,dy] = feval(func,y);
for it=1:maxit
  xold = x;
  [fx,dx] = feval(func,x);
  i = find(dy~=dx & abs(y-x)>tol);
  x(i) = x(i) - ((y(i)-x(i))./(dy(i)-dx(i)).*dx(i));
  x(i) = min(x(i),b(i));
  x(i) = max(x(i),a(i));
  if norm(x-xold,inf) < tol, return, end;
  y = xold;
  fy = fx;
  dy = dx;
end
