function x=jacobi(A,b,tol);

% JACOBI: x = jacobi(A,b,tol)
%
% Solves Ax=b to tolerance tol using Jacobi iteration.

maxit = 1000;
d = diag(A);
b = b./d;
A = speye(size(A))-A./d(:,ones(length(d),1));
x = sparse(b);

for it=1:maxit
   delx = A*x+b-x;
   x = x + delx;
   if norm(delx)<tol break; end
end
if it>=maxit; disp('Maximum iterations reached in Jacobi'); end
